function hudtools.greenRedInterpol( factor )
	local r
	local g
	if factor < 0.5 then
		r = 512*factor
		g = 255
	else
		r = 255
		g = 255 - 512*(factor-0.5)
	end
	return color(r, g, 0)
end

function hudtools.redgreenInterpol( factor )
	local r
	local g
if factor < 0 then
r = 255
g = 0
	elseif factor < 0.5 then
		r = 255
		g = 512*factor
	else
		r = 255 - 512*(factor-0.5)
		g = 255
	end
	return color(r, g, 0)
end

function hudtools.greenInterpol( factor )
	local r
	local g
	local b
		r = factor*175
		g = 255-(factor*80)
		b = factor*175

	return color(r, g, b)
end

function hudtools.blueInterpol( factor )
	local r
	local g
	local b
		r = (factor*115) + 77
		g = (factor*73) + 143
		b = (factor*46) + 183

	return color(r, g, b)
end

function hudtools.drawHBar(bitmap, filled, x, y, width, height)
	gfx_set_alpha(160)
	bitmap:draw_box(x, y, x+width, y+height, 0)
	gfx_reset_blending()
	if filled > 0 then
		bitmap:draw_box(x, y, x+(width)*filled, y+height, hudtools.greenRedInterpol(1-filled))
	end
end

function hudtools.drawVBar(bitmap, filled, x, y, width, height)
	gfx_set_alpha(160)
	bitmap:draw_box(x-width, y-height, x, y, 0)
	gfx_reset_blending()
	if filled > 0 then
		bitmap:draw_box(x-width, y-(height)*filled, x, y, hudtools.greenInterpol(1-filled))
	end

end

function hudtools.drawVBlue(bitmap, filled, x, y, width, height)
	gfx_set_alpha(160)
	bitmap:draw_box(x-width, y-height, x, y, 0)
	gfx_reset_blending()
	if filled > 0 then
		bitmap:draw_box(x-width, y-(height)*filled, x, y, hudtools.blueInterpol(1-filled))
	end

end

function hudtools.madBar(bitmap, filled, x, y, width, height)
	gfx_set_alpha(160)
	bitmap:draw_box(x-width, y-height, x, y, 0)
	gfx_reset_blending()
	if filled > 0 then
		bitmap:draw_box(x-width, y-(height)*filled, x, y, hudtools.redgreenInterpol(1-filled))
	end

end