-- Author: Wesz
-- Email: lukash.pietrzak@gmail.com
-- WWW: http://wesz.rtu.pl/

function walljump.init()

	local bottom = tonumber(console["sv_worm_weapon_height"])
	local top = bottom - tonumber(console["sv_worm_height"])
	local left = -tonumber(console["sv_worm_width"]) / 2
	local right = tonumber(console["sv_worm_width"]) / 2
	local wall = load_particle("wall.obj")
	local jumpForce = 1.4
	
	local xSpdAdd = -0.4 --jezeli sila poziomego odrzutu od sciany bedzie zbyt mala, wpisz tu liczbe wieksza od zera
	local ySpdAdd =  0.2 -- to samo co wyzej, z tym ze dla odrzutu pionowego
	local collisionCheck = 5 -- liczba pikseli na scianie ktora musi dotykac robak, aby sie odbic
	
	function bindings.playerInit(p)
		p:data().reacts = {left = 0, right = 0}
	end
	
	function bindings.playerUpdate(p)
		local wx, wy = p:worm():pos()
		local wvx, wvy = p:worm():spd()
		local d = p:data()
		
		d.reacts = {left = 0, right = 0}
		
		for i = 0, top-1 do
			if not map_is_particle_pass(wx + left - 1, wy - i) then
				d.reacts.left = d.reacts.left + 1
			end
			if not map_is_particle_pass(wx + right + 1, wy - i) then
				d.reacts.right = d.reacts.right + 1
			end
		end
		
		for i = 0, bottom-1 do
			if not map_is_particle_pass(wx + left - 1, wy + i) then
				d.reacts.left = d.reacts.left + 1
			end
			if not map_is_particle_pass(wx + right + 1, wy + i) then
				d.reacts.right = d.reacts.right + 1
			end
		end
	end
	
	function bindings.localplayerEvent(player, event, state)
		local wx, wy = player:worm():pos()
		local wvx, wvy = player:worm():spd()
		local d = player:data()
	
		if event == Player.Jump and state and player:worm():health() > 0 then
			if not map_is_particle_pass(wx + left - 1, wy) then
				if d.reacts.left == collisionCheck then
					player:worm():set_spd(jumpForce + xSpdAdd, -jumpForce - ySpdAdd)
   local sound = sounds["jump.ogg"]
   local x,y = player:worm():pos()
   sound:play(x, y, 140, 1, 0.05)
   player:worm():shoot(wall, 2 , 0.2, 0.1, 0, 0, 30, 0, 0 )
   player:worm():shoot(wall, 2 , 0.2, 0.1, 0, 0, 30, 180, 0 )

				end
			elseif not map_is_particle_pass(wx + right + 1, wy) then
				if d.reacts.right == collisionCheck then
					player:worm():set_spd(-jumpForce - xSpdAdd , -jumpForce - ySpdAdd)
   local sound = sounds["jump.ogg"]
   local x,y = player:worm():pos()
   sound:play(x, y, 140, 1, 0.05)
   player:worm():shoot(wall, 2 , 0.2, 0.1, 0, 0, 30, 0, 0 )
   player:worm():shoot(wall, 2 , 0.2, 0.1, 0, 0, 30, 180, 0 )

				end
			end
		end
	end
end
